/*
   All emon_widgets code is released under the GNU General Public License v3.
   See COPYRIGHT.txt and LICENSE.txt.

    ---------------------------------------------------------------------
    Part of the OpenEnergyMonitor project:
    http://openenergymonitor.org

    Author: Trystan Lea: trystan.lea@googlemail.com
    If you have any questions please get in touch, try the forums here:
    http://openenergymonitor.org/emon/forum
 */

function square_widgetlist()
{
  var widgets = {
    "square":
    {
      "offsetx":-40,"offsety":-40,"width":80,"height":80,
      "menu":"Widgets",
      "options":["feedid"],
      "optionstype":["feedid"],
      "optionsname":[_Tr("Feed")],
      "optionshint":[_Tr("Feed value")]
    }
  }
  return widgets;
}

function square_init()
{
  setup_widget_canvas('square');
}

function square_draw() {
  $('.square').each(function(index)
  {
    var feedid = $(this).attr("feedid");
    if (associd[feedid] === undefined) { console.log("Review config for feed id of " + $(this).attr("class")); return; }
    var val = associd[feedid]['value'] * 1;
    var id = "can-"+$(this).attr("id");
    if (browserVersion < 9)
      draw_square_ie8(widgetcanvas[id], val);
    else
      draw_square(widgetcanvas[id], val);
  });
}

function square_slowupdate() {
  square_draw();
}

function square_fastupdate() {}

function draw_square(rectangle,status){
  if (!rectangle) return;

  var width = rectangle.canvas.width;
  var height = rectangle.canvas.height;
  var borderx = Math.min(40, Math.floor(width/2));
  var bordery = Math.min(40, Math.floor(height/2));
  var dimension = Math.max(40, Math.min(width*borderx, height*bordery));
  var offsetx = Math.floor((width - dimension) / 2.0);
  var offsety = Math.floor((height - dimension) / 2.0);

  rectangle.clearRect(0,0,width,height);

  var radgrad = rectangle.createRadialGradient(width/2,height/2,0,width/2,height/2,dimension/2);

  if (status==0) {                   // black
    radgrad.addColorStop(0, '#000000');
    radgrad.addColorStop(0.9, '#000000');
  } else if (status>0 && status <=1) {            // green
    radgrad.addColorStop(0, '#A7D30C');
    radgrad.addColorStop(0.9, '#019F62');
  } else if (status>1 && status <=2) {           // grey
    radgrad.addColorStop(0, '#736F6E');
    radgrad.addColorStop(0.9, '#4A4344');
  } else if (status>2 && status <=3) { 		  //Blue
    radgrad.addColorStop(0, '#00C9FF');
    radgrad.addColorStop(0.9, '#00B5E2');
  } else if (status>3 && status <=4) {		  // Purple
    radgrad.addColorStop(0, '#FF5F98');
    radgrad.addColorStop(0.9, '#FF0188');
  } else if (status>4 && status <=5)   {         // yellow
    radgrad.addColorStop(0, '#F4F201');
    radgrad.addColorStop(0.9, '#E4C700');
  } else {					  // Black
    radgrad.addColorStop(0, '#000000');
    radgrad.addColorStop(0.9, '#000000');
  }

  radgrad.addColorStop(1, 'rgba(1,159,98,0)');
  // draw shapes
  rectangle.fillStyle = radgrad;
  rectangle.fillRect(offsetx,offsety,dimension,dimension);
}


function draw_square_ie8(rectangle,status){
  if (!rectangle) return;

  if (status==0) {			// black
    rectangle.fillStyle = "#000000";
  } else if (status==1) {			// green
    rectangle.fillStyle = "#019F62";
  } else if (status==2) {			// grey
    rectangle.fillStyle = "#4A4344";
  } else if (status==3) {			//Blue
    rectangle.fillStyle = "#00B5E2";
  } else if (status ==4) {		// Purple
    rectangle.fillStyle = "#FF0188";
  } else if (status==5)  {		// yellow
    rectangle.fillStyle = "#E4C700";
  } else {				// Black
    rectangle.fillStyle = "#000000";
  }

  rectangle.beginPath();
  rectangle.arc(25,25,20, 0,2,false);
  rectangle.closePath();
  rectangle.fill()
}

function draw_binary_square(rectangle,status){
  if (!rectangle) return;
  rectangle.clearRect(0,0,80,80);

  var radgrad = rectangle.createRadialGradient(40,40,0,40,40,20);

  if (status==0) {                               // black
    radgrad.addColorStop(0, '#000000');
    radgrad.addColorStop(0.9, '#000000');
  } else {                                       // green
    radgrad.addColorStop(0, '#A7D30C');
    radgrad.addColorStop(0.9, '#019F62');
  }

  radgrad.addColorStop(1, 'rgba(1,159,98,0)');
  // draw shapes
  rectangle.fillStyle = radgrad;
  rectangle.fillRect(20,20,60,60);
}

function draw_binary_square_ie8(rectangle,status){
  if (!rectangle) return;

  if (status==0) {			// black
    rectangle.fillStyle = "#000000";
  } else {			// green
    rectangle.fillStyle = "#019F62";
  }

  rectangle.beginPath();
  rectangle.arc(25,25,20, 0,Math.PI * 2,false);
  rectangle.closePath();
  rectangle.fill()
}


